VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "  Sprite Animation Demo"
   ClientHeight    =   7275
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   13590
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7275
   ScaleWidth      =   13590
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   0
      Top             =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const BG_File As String = "C:\Background.bmp"
Private Const Img_File As String = "C:\Image.bmp"

Private cBG         As cSprite_Background
Private cImage(10)  As cSprite_Bitmap

Private Sub Form_Load()
  
  Dim MyCounter As Integer
  Dim PicBG     As StdPicture
  Dim PicImg    As StdPicture
  Dim TheHeight As Long
  Dim TheWidth  As Long
  
  ' Extract the background and the image to the specified files
  If ExtractFromRES(BG_File, 1, , rt_Bitmap) = False Then
    GoTo ErrorOut
  ElseIf ExtractFromRES(Img_File, 2, , rt_Bitmap) = False Then
    GoTo ErrorOut
  End If
  
  ' Load the extracted picture files
  Set PicBG = LoadPicture(BG_File)
  Set PicImg = LoadPicture(Img_File)
  Kill Img_File
  Kill BG_File
  
  ' Convert the measurements of the pictures form their standard measurement (HiMetric)
  ' to the Win32 API standard measurement (Pixels).
  Convert_HM_PX PicBG.Height, PicBG.Width, TheHeight, TheWidth, True
  
  ' Set the form to automatically redraw itself so the images aren't lost
  With Me
    .AutoRedraw = True
    .ScaleMode = vbPixels
    .Left = 0
    .Top = 0
    .ScaleHeight = TheHeight
    .ScaleWidth = TheWidth
    .Caption = "Sprite Animation Demo"
    .Show
  End With
  
  ' Set the picture for the background
  Set cBG = New cSprite_Background
  cBG.hPicture = PicBG.Handle
  cBG.Render Me.hDC
  RefreshHWND Me.hwnd
  
  ' Set the picture for the sprite and specify the transparency color
  For MyCounter = 0 To 10
    Set cImage(MyCounter) = New cSprite_Bitmap
    cImage(MyCounter).TransparentColor = CLng("&H00FF00")
    cImage(MyCounter).hPicture = PicImg.Handle
    cImage(MyCounter).Render Me.hDC
    RefreshHWND Me.hwnd
    
    ' Specify the velocity of the image
    Randomize
    cImage(MyCounter).VelocityX = CLng((10 * Rnd) + 0)
    Randomize
    cImage(MyCounter).VelocityY = CLng((10 * Rnd) + 0)
    If cImage(MyCounter).VelocityX = 0 And cImage(MyCounter).VelocityY = 0 Then
      cImage(MyCounter).VelocityX = 1
    End If
  Next
  
  ' Start the loop that draws the sprite animation
  Timer1.Interval = 15
  Timer1.Enabled = True
  
  Set PicBG = Nothing
  Set PicImg = Nothing
  
  Exit Sub
  
ErrorOut:
  
  On Error Resume Next
  MsgBox "An error occured while trying to load the pictures to use." & Chr(13) & Chr(13) & "Make sure that 'Background.bmp' and 'Image.bmp' exist on the 'C' drive in the root directory and that they are valid image files.", vbOKOnly + vbExclamation, "  Error Loading Images"
  Kill Img_File
  Kill BG_File
  Unload Me
  
End Sub

Private Sub Form_Unload(Cancel As Integer)
On Error Resume Next
  
  Dim MyCounter As Integer
  
  Set cBG = Nothing
  For MyCounter = 0 To 10
    Set cImage(MyCounter) = Nothing
  Next
  
End Sub

Private Sub Timer1_Timer()
  
  Dim MyCounter As Integer
  Dim TempDC    As Long
  Dim TempBMP   As Long
  Dim PrevBMP   As Long
  Dim hScreenDC As Long
  
  ' Create a buffer to draw to, then paint to the destination... this eliminates flicker
  ' and sprite overlap mis-drawing.
  TempDC = MemoryDC_Create
  hScreenDC = GetDC(GetDesktopWindow)
  TempBMP = CreateCompatibleBitmap(hScreenDC, cBG.Width, cBG.Height)
  ReleaseDC GetDesktopWindow, hScreenDC
  LoadPictureToDC TempDC, TempBMP, PrevBMP
  
  ' Draw the background onto the buffer
  cBG.Render TempDC
  
  ' Draw the sprites to the buffer
  For MyCounter = 0 To 10
    With cImage(MyCounter)
      
      ' Increment the image's location
      .CurrentX = .CurrentX + .VelocityX
      .CurrentY = .CurrentY + .VelocityY
      
      ' Keep the image within the viewable area
      If .CurrentX > cBG.Width Then .CurrentX = -1 * .Width
      If .CurrentY > cBG.Height Then .CurrentY = -1 * .Height
      
      ' Draw the image in the new place
      .Render TempDC, .CurrentX, .CurrentY, , , , False
    End With
  Next
  
  ' Draw the buffer to the destination
  BitBlt Form1.hDC, 0, 0, cBG.Width, cBG.Height, TempDC, 0, 0, SRCCOPY
  RefreshHWND Me.hwnd
  
  ' Clean up the memory used
  MemoryDC_Delete TempDC, PrevBMP
  
End Sub
